#include <stdio.h>
#include <string.h>

#include "lib.h"

int cat(char *filename) {
	char *rename;
	FILE *in;
	int result;
	result = 0;
	rename = filename;
	in = filename_adjust_open(&rename, "r");
	if (!in)
		return -1;
	copy_all(in, rename, stdout, "(standard output)");
	if (ferror(in) || ferror(stdout))
		result = -1;
	if (fclose(in))
		result = -1;
	return result;
}

int main(int argc, char **argv) {
	size_t i;
	int result;
	progname = argv[0];
	for (i = 1; i < argc && argv[i][0] == '-' && argv[i][1]; i++) {
		if (!strcmp(argv[i], "--version")) {
			version("cat");
			return 0;
		} else if (!strcmp(argv[i], "--help")) {
			version("cat");
			fprintf(stderr,
				"\n%s [INPUT ...]\n"
				"\tConcatenate the INPUT files to standard output\n"
				"%s --version\n"
				"\tDisplay this usage message.\n",
				progname, progname, progname);
			return 0;
		} else {
			fprintf(stderr, "%s: invalid %s (%s --help for usage)\n", progname,
				argv[i], progname);
			return 1;
		}
	}
	result = 0;
	if (i == argc && cat("-"))
		result = 1;
	for (; i < argc; i++)
		if (cat(argv[i]))
			result = 1;
	return result;
}
